'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};

var asyncToGenerator = function (fn) {
  return function () {
    var gen = fn.apply(this, arguments);
    return new Promise(function (resolve, reject) {
      function step(key, arg) {
        try {
          var info = gen[key](arg);
          var value = info.value;
        } catch (error) {
          reject(error);
          return;
        }

        if (info.done) {
          resolve(value);
        } else {
          return Promise.resolve(value).then(function (value) {
            step("next", value);
          }, function (err) {
            step("throw", err);
          });
        }
      }

      return step("next");
    });
  };
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

Function.prototype.$asyncbind = function $asyncbind(self, catcher) {

  if (!Function.prototype.$asyncbind) {
    Object.defineProperty(Function.prototype, "$asyncbind", {
      value: $asyncbind,
      enumerable: false,
      configurable: true,
      writable: true
    });
  }

  if (!$asyncbind.trampoline) {
    $asyncbind.trampoline = function trampoline(t, x, s, e, u) {
      return function b(q) {
        while (q) {
          if (q.then) {
            q = q.then(b, e);
            return u ? undefined : q;
          }

          try {
            if (q.pop) {
              if (q.length) return q.pop() ? x.call(t) : q;
              q = s;
            } else q = q.call(t);
          } catch (r) {
            return e(r);
          }
        }
      };
    };
  }

  if (!$asyncbind.LazyThenable) {
    $asyncbind.LazyThenable = function () {
      function isThenable(obj) {
        return obj && obj instanceof Object && typeof obj.then === "function";
      }

      function resolution(p, r, how) {
        try {
          var x = how ? how(r) : r;
          if (p === x) return p.reject(new TypeError("Promise resolution loop"));

          if (isThenable(x)) {
            x.then(function (y) {
              resolution(p, y);
            }, function (e) {
              p.reject(e);
            });
          } else {
            p.resolve(x);
          }
        } catch (ex) {
          p.reject(ex);
        }
      }

      function _unchained(v) {}

      function thenChain(res, rej) {
        this.resolve = res;
        this.reject = rej;
      }

      function Chained() {}
      Chained.prototype = {
        resolve: _unchained,
        reject: _unchained,
        then: thenChain
      };

      function then(res, rej) {
        var chain = new Chained();

        try {
          this._resolver(function (value) {
            return isThenable(value) ? value.then(res, rej) : resolution(chain, value, res);
          }, function (ex) {
            resolution(chain, ex, rej);
          });
        } catch (ex) {
          resolution(chain, ex, rej);
        }

        return chain;
      }

      function Thenable(resolver) {
        this._resolver = resolver;
        this.then = then;
      }

      Thenable.resolve = function (v) {
        return Thenable.isThenable(v) ? v : {
          then: function then(resolve) {
            return resolve(v);
          }
        };
      };

      Thenable.isThenable = isThenable;
      return Thenable;
    }();

    $asyncbind.EagerThenable = $asyncbind.Thenable = ($asyncbind.EagerThenableFactory = function (tick) {
      tick = tick || (typeof process === 'undefined' ? 'undefined' : _typeof(process)) === "object" && process.nextTick || typeof setImmediate === "function" && setImmediate || function (f) {
        setTimeout(f, 0);
      };

      var soon = function () {
        var fq = [],
            fqStart = 0,
            bufferSize = 1024;

        function callQueue() {
          while (fq.length - fqStart) {
            try {
              fq[fqStart]();
            } catch (ex) {}

            fq[fqStart++] = undefined;

            if (fqStart === bufferSize) {
              fq.splice(0, bufferSize);
              fqStart = 0;
            }
          }
        }

        return function (fn) {
          fq.push(fn);
          if (fq.length - fqStart === 1) tick(callQueue);
        };
      }();

      function Zousan(func) {
        if (func) {
          var me = this;
          func(function (arg) {
            me.resolve(arg);
          }, function (arg) {
            me.reject(arg);
          });
        }
      }

      Zousan.prototype = {
        resolve: function resolve(value) {
          if (this.state !== undefined) return;
          if (value === this) return this.reject(new TypeError("Attempt to resolve promise with self"));
          var me = this;

          if (value && (typeof value === "function" || (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === "object")) {
            try {
              var first = 0;
              var then = value.then;

              if (typeof then === "function") {
                then.call(value, function (ra) {
                  if (!first++) {
                    me.resolve(ra);
                  }
                }, function (rr) {
                  if (!first++) {
                    me.reject(rr);
                  }
                });
                return;
              }
            } catch (e) {
              if (!first) this.reject(e);
              return;
            }
          }

          this.state = STATE_FULFILLED;
          this.v = value;
          if (me.c) soon(function () {
            for (var n = 0, l = me.c.length; n < l; n++) {
              STATE_FULFILLED(me.c[n], value);
            }
          });
        },
        reject: function reject(reason) {
          if (this.state !== undefined) return;
          this.state = STATE_REJECTED;
          this.v = reason;
          var clients = this.c;
          if (clients) soon(function () {
            for (var n = 0, l = clients.length; n < l; n++) {
              STATE_REJECTED(clients[n], reason);
            }
          });
        },
        then: function then(onF, onR) {
          var p = new Zousan();
          var client = {
            y: onF,
            n: onR,
            p: p
          };

          if (this.state === undefined) {
            if (this.c) this.c.push(client);else this.c = [client];
          } else {
            var s = this.state,
                a = this.v;
            soon(function () {
              s(client, a);
            });
          }

          return p;
        }
      };

      function STATE_FULFILLED(c, arg) {
        if (typeof c.y === "function") {
          try {
            var yret = c.y.call(undefined, arg);
            c.p.resolve(yret);
          } catch (err) {
            c.p.reject(err);
          }
        } else c.p.resolve(arg);
      }

      function STATE_REJECTED(c, reason) {
        if (typeof c.n === "function") {
          try {
            var yret = c.n.call(undefined, reason);
            c.p.resolve(yret);
          } catch (err) {
            c.p.reject(err);
          }
        } else c.p.reject(reason);
      }

      Zousan.resolve = function (val) {
        if (val && val instanceof Zousan) return val;
        var z = new Zousan();
        z.resolve(val);
        return z;
      };

      Zousan.reject = function (err) {
        if (err && err instanceof Zousan) return err;
        var z = new Zousan();
        z.reject(err);
        return z;
      };

      Zousan.version = "2.3.3-nodent";
      return Zousan;
    })();
  }

  function boundThen() {
    return resolver.apply(self, arguments);
  }

  var resolver = this;

  switch (catcher) {
    case true:
      return new $asyncbind.Thenable(boundThen);

    case 0:
      return new $asyncbind.LazyThenable(boundThen);

    case undefined:
      boundThen.then = boundThen;
      return boundThen;

    default:
      return function () {
        try {
          return resolver.apply(self, arguments);
        } catch (ex) {
          return catcher(ex);
        }
      };
  }
};

var millisecondsPerDay = 24 * 60 * 60 * 1000;

var subDays = function subDays(date, days) {
  return new Date(date.getTime() - days * millisecondsPerDay);
};

var addMilliseconds = function addMilliseconds(date, millis) {
  return new Date(date.getTime() + millis);
};

var isAfter = function isAfter(a, b) {
  return Date.parse(a) > Date.parse(b);
};

var endOfDay = function endOfDay(date) {
  var endOfDay = new Date(date);
  endOfDay.setUTCHours(23, 59, 59, 999);
  return endOfDay;
};

var generateRanges = function generateRanges() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$endingDate = _ref.endingDate,
      endingDate = _ref$endingDate === undefined ? endOfDay(Date.now()) : _ref$endingDate,
      _ref$daysInRange = _ref.daysInRange,
      daysInRange = _ref$daysInRange === undefined ? 7 : _ref$daysInRange,
      _ref$rangeCount = _ref.rangeCount,
      rangeCount = _ref$rangeCount === undefined ? 4 : _ref$rangeCount;

  return Array.from({ length: rangeCount }, function (v, i) {
    var from = addMilliseconds(subDays(endingDate, daysInRange * (rangeCount - i)), 1);
    var to = subDays(endingDate, daysInRange * (rangeCount - i - 1));
    return {
      from: from,
      to: to
    };
  });
};

var getWeekIndex = function getWeekIndex(date, weeks) {
  return weeks.findIndex(function (week) {
    return isAfter(date, week.from) && isAfter(week.to, date);
  });
};

var groupInitialEventsByWeek = function groupInitialEventsByWeek(initalEvents, ranges) {
  var grouped = ranges.map(function (w) {
    return new Map();
  });
  initalEvents.forEach(function (initialEvent) {
    var rangeIndex = getWeekIndex(initialEvent.date, ranges);
    if (rangeIndex < 0) {
      return;
    }
    grouped[rangeIndex].set(initialEvent.id, initialEvent.date);
  });
  return grouped;
};

var getActiveInstances = function () {
  var _ref2 = asyncToGenerator(function* (getActivity, from, to, weekIndex) {
    var functions = (typeof getActivity === 'undefined' ? 'undefined' : _typeof(getActivity)) === 'object' ? getActivity : { activity: getActivity };
    var all = yield Promise.all(Object.keys(functions).map(function () {
      var _ref3 = asyncToGenerator(function* (name) {
        var f = functions[name];
        var results = yield f(from, to, weekIndex);
        return {
          name: name,
          results: results
        };
      });

      return function (_x6) {
        return _ref3.apply(this, arguments);
      };
    }()));

    var activity = new Map();

    all.forEach(function (activityResults) {
      var name = activityResults.name;
      activityResults.results.forEach(function (instance) {
        if (activity.has(instance)) {
          activity.get(instance).push(name);
        } else {
          activity.set(instance, [name]);
        }
      });
    });
    return activity;
  });

  return function getActiveInstances(_x2, _x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var getActivityInRanges = function () {
  var _ref4 = asyncToGenerator(function* (getActivity, ranges) {
    var activityInRanges = [];
    for (var rangeIndex in ranges) {
      var range = ranges[rangeIndex];
      var activity = yield getActiveInstances(getActivity, range.from, range.to, rangeIndex);
      activityInRanges[rangeIndex] = activity;
    }
    return activityInRanges;
  });

  return function getActivityInRanges(_x7, _x8) {
    return _ref4.apply(this, arguments);
  };
}();

var getInstancesActiveInRange = function getInstancesActiveInRange(initialEventInRange, activity) {
  var activeInstances = new Map();
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = activity[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _ref5 = _step.value;

      var _ref6 = slicedToArray(_ref5, 2);

      var instanceId = _ref6[0];
      var instanceActivity = _ref6[1];

      if (initialEventInRange.has(instanceId)) {
        activeInstances.set(instanceId, instanceActivity);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return activeInstances;
};

var buildRetentionMatrix = function buildRetentionMatrix(_ref7) {
  var dateRanges = _ref7.dateRanges,
      activityInRanges = _ref7.activityInRanges,
      groupedInitialEvents = _ref7.groupedInitialEvents;

  return dateRanges.map(function (range, rangeIndex) {
    var initialEventInRange = groupedInitialEvents[rangeIndex];

    var activity = Object.keys(activityInRanges).filter(function (index) {
      return index >= rangeIndex;
    }).map(function (index, i) {
      var activity = activityInRanges[index];
      var activeInstances = getInstancesActiveInRange(initialEventInRange, activity);
      var activeCount = activeInstances.size;
      var evalsCount = initialEventInRange.size;
      var percentage = Math.round(activeCount / evalsCount * 100);
      return {
        activeCount: activeCount,
        percentage: percentage,
        active: [].concat(toConsumableArray(activeInstances)).map(function (_ref8) {
          var _ref9 = slicedToArray(_ref8, 2),
              k = _ref9[0],
              v = _ref9[1];

          return { id: k, events: v };
        })
      };
    });

    return {
      range: range,
      activity: activity,
      cohort: [].concat(toConsumableArray(initialEventInRange.entries())).map(function (_ref10) {
        var _ref11 = slicedToArray(_ref10, 2),
            k = _ref11[0],
            v = _ref11[1];

        return { id: k, date: v };
      })
    };
  });
};

var buildMatrix = function () {
  var _ref13 = asyncToGenerator(function* (_ref12) {
    var _ref12$dateRanges = _ref12.dateRanges,
        dateRanges = _ref12$dateRanges === undefined ? generateRanges() : _ref12$dateRanges,
        getInitialEvents = _ref12.getInitialEvents,
        getActivity = _ref12.getActivity;

    var initialEvents = yield getInitialEvents();
    var groupedInitialEvents = groupInitialEventsByWeek(initialEvents, dateRanges);
    var activityInRanges = yield getActivityInRanges(getActivity, dateRanges);
    var matrix = buildRetentionMatrix({ dateRanges: dateRanges, groupedInitialEvents: groupedInitialEvents, activityInRanges: activityInRanges });
    return matrix;
  });

  return function buildMatrix(_x9) {
    return _ref13.apply(this, arguments);
  };
}();

exports.generateRanges = generateRanges;
exports.buildMatrix = buildMatrix;
