(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('c3')) :
  typeof define === 'function' && define.amd ? define(['exports', 'c3'], factory) :
  (factory((global.Retention = {}),global.c3));
}(this, (function (exports,c3) { 'use strict';

  c3 = c3 && c3.hasOwnProperty('default') ? c3['default'] : c3;

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  var asyncToGenerator = function (fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  };

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var slicedToArray = function () {
    function sliceIterator(arr, i) {
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"]) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    return function (arr, i) {
      if (Array.isArray(arr)) {
        return arr;
      } else if (Symbol.iterator in Object(arr)) {
        return sliceIterator(arr, i);
      } else {
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      }
    };
  }();

  var taggedTemplateLiteral = function (strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  };

  var toConsumableArray = function (arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    } else {
      return Array.from(arr);
    }
  };

  Function.prototype.$asyncbind = function $asyncbind(self, catcher) {

    if (!Function.prototype.$asyncbind) {
      Object.defineProperty(Function.prototype, "$asyncbind", {
        value: $asyncbind,
        enumerable: false,
        configurable: true,
        writable: true
      });
    }

    if (!$asyncbind.trampoline) {
      $asyncbind.trampoline = function trampoline(t, x, s, e, u) {
        return function b(q) {
          while (q) {
            if (q.then) {
              q = q.then(b, e);
              return u ? undefined : q;
            }

            try {
              if (q.pop) {
                if (q.length) return q.pop() ? x.call(t) : q;
                q = s;
              } else q = q.call(t);
            } catch (r) {
              return e(r);
            }
          }
        };
      };
    }

    if (!$asyncbind.LazyThenable) {
      $asyncbind.LazyThenable = function () {
        function isThenable(obj) {
          return obj && obj instanceof Object && typeof obj.then === "function";
        }

        function resolution(p, r, how) {
          try {
            var x = how ? how(r) : r;
            if (p === x) return p.reject(new TypeError("Promise resolution loop"));

            if (isThenable(x)) {
              x.then(function (y) {
                resolution(p, y);
              }, function (e) {
                p.reject(e);
              });
            } else {
              p.resolve(x);
            }
          } catch (ex) {
            p.reject(ex);
          }
        }

        function _unchained(v) {}

        function thenChain(res, rej) {
          this.resolve = res;
          this.reject = rej;
        }

        function Chained() {}
        Chained.prototype = {
          resolve: _unchained,
          reject: _unchained,
          then: thenChain
        };

        function then(res, rej) {
          var chain = new Chained();

          try {
            this._resolver(function (value) {
              return isThenable(value) ? value.then(res, rej) : resolution(chain, value, res);
            }, function (ex) {
              resolution(chain, ex, rej);
            });
          } catch (ex) {
            resolution(chain, ex, rej);
          }

          return chain;
        }

        function Thenable(resolver) {
          this._resolver = resolver;
          this.then = then;
        }

        Thenable.resolve = function (v) {
          return Thenable.isThenable(v) ? v : {
            then: function then(resolve) {
              return resolve(v);
            }
          };
        };

        Thenable.isThenable = isThenable;
        return Thenable;
      }();

      $asyncbind.EagerThenable = $asyncbind.Thenable = ($asyncbind.EagerThenableFactory = function (tick) {
        tick = tick || (typeof process === 'undefined' ? 'undefined' : _typeof(process)) === "object" && process.nextTick || typeof setImmediate === "function" && setImmediate || function (f) {
          setTimeout(f, 0);
        };

        var soon = function () {
          var fq = [],
              fqStart = 0,
              bufferSize = 1024;

          function callQueue() {
            while (fq.length - fqStart) {
              try {
                fq[fqStart]();
              } catch (ex) {}

              fq[fqStart++] = undefined;

              if (fqStart === bufferSize) {
                fq.splice(0, bufferSize);
                fqStart = 0;
              }
            }
          }

          return function (fn) {
            fq.push(fn);
            if (fq.length - fqStart === 1) tick(callQueue);
          };
        }();

        function Zousan(func) {
          if (func) {
            var me = this;
            func(function (arg) {
              me.resolve(arg);
            }, function (arg) {
              me.reject(arg);
            });
          }
        }

        Zousan.prototype = {
          resolve: function resolve(value) {
            if (this.state !== undefined) return;
            if (value === this) return this.reject(new TypeError("Attempt to resolve promise with self"));
            var me = this;

            if (value && (typeof value === "function" || (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === "object")) {
              try {
                var first = 0;
                var then = value.then;

                if (typeof then === "function") {
                  then.call(value, function (ra) {
                    if (!first++) {
                      me.resolve(ra);
                    }
                  }, function (rr) {
                    if (!first++) {
                      me.reject(rr);
                    }
                  });
                  return;
                }
              } catch (e) {
                if (!first) this.reject(e);
                return;
              }
            }

            this.state = STATE_FULFILLED;
            this.v = value;
            if (me.c) soon(function () {
              for (var n = 0, l = me.c.length; n < l; n++) {
                STATE_FULFILLED(me.c[n], value);
              }
            });
          },
          reject: function reject(reason) {
            if (this.state !== undefined) return;
            this.state = STATE_REJECTED;
            this.v = reason;
            var clients = this.c;
            if (clients) soon(function () {
              for (var n = 0, l = clients.length; n < l; n++) {
                STATE_REJECTED(clients[n], reason);
              }
            });
          },
          then: function then(onF, onR) {
            var p = new Zousan();
            var client = {
              y: onF,
              n: onR,
              p: p
            };

            if (this.state === undefined) {
              if (this.c) this.c.push(client);else this.c = [client];
            } else {
              var s = this.state,
                  a = this.v;
              soon(function () {
                s(client, a);
              });
            }

            return p;
          }
        };

        function STATE_FULFILLED(c, arg) {
          if (typeof c.y === "function") {
            try {
              var yret = c.y.call(undefined, arg);
              c.p.resolve(yret);
            } catch (err) {
              c.p.reject(err);
            }
          } else c.p.resolve(arg);
        }

        function STATE_REJECTED(c, reason) {
          if (typeof c.n === "function") {
            try {
              var yret = c.n.call(undefined, reason);
              c.p.resolve(yret);
            } catch (err) {
              c.p.reject(err);
            }
          } else c.p.reject(reason);
        }

        Zousan.resolve = function (val) {
          if (val && val instanceof Zousan) return val;
          var z = new Zousan();
          z.resolve(val);
          return z;
        };

        Zousan.reject = function (err) {
          if (err && err instanceof Zousan) return err;
          var z = new Zousan();
          z.reject(err);
          return z;
        };

        Zousan.version = "2.3.3-nodent";
        return Zousan;
      })();
    }

    function boundThen() {
      return resolver.apply(self, arguments);
    }

    var resolver = this;

    switch (catcher) {
      case true:
        return new $asyncbind.Thenable(boundThen);

      case 0:
        return new $asyncbind.LazyThenable(boundThen);

      case undefined:
        boundThen.then = boundThen;
        return boundThen;

      default:
        return function () {
          try {
            return resolver.apply(self, arguments);
          } catch (ex) {
            return catcher(ex);
          }
        };
    }
  };

  var millisecondsPerDay = 24 * 60 * 60 * 1000;

  var subDays = function subDays(date, days) {
    return new Date(date.getTime() - days * millisecondsPerDay);
  };

  var addMilliseconds = function addMilliseconds(date, millis) {
    return new Date(date.getTime() + millis);
  };

  var isAfter = function isAfter(a, b) {
    return Date.parse(a) > Date.parse(b);
  };

  var endOfDay = function endOfDay(date) {
    var endOfDay = new Date(date);
    endOfDay.setUTCHours(23, 59, 59, 999);
    return endOfDay;
  };

  var generateRanges = function generateRanges() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$endingDate = _ref.endingDate,
        endingDate = _ref$endingDate === undefined ? endOfDay(Date.now()) : _ref$endingDate,
        _ref$daysInRange = _ref.daysInRange,
        daysInRange = _ref$daysInRange === undefined ? 7 : _ref$daysInRange,
        _ref$rangeCount = _ref.rangeCount,
        rangeCount = _ref$rangeCount === undefined ? 4 : _ref$rangeCount;

    return Array.from({ length: rangeCount }, function (v, i) {
      var from = addMilliseconds(subDays(endingDate, daysInRange * (rangeCount - i)), 1);
      var to = subDays(endingDate, daysInRange * (rangeCount - i - 1));
      return {
        from: from,
        to: to
      };
    });
  };

  var getWeekIndex = function getWeekIndex(date, weeks) {
    return weeks.findIndex(function (week) {
      return isAfter(date, week.from) && isAfter(week.to, date);
    });
  };

  var groupInitialEventsByWeek = function groupInitialEventsByWeek(initalEvents, ranges) {
    var grouped = ranges.map(function (w) {
      return new Map();
    });
    initalEvents.forEach(function (initialEvent) {
      var rangeIndex = getWeekIndex(initialEvent.date, ranges);
      if (rangeIndex < 0) {
        return;
      }
      grouped[rangeIndex].set(initialEvent.id, initialEvent.date);
    });
    return grouped;
  };

  var getActiveInstances = function () {
    var _ref2 = asyncToGenerator(function* (getActivity, from, to, weekIndex) {
      var functions = (typeof getActivity === 'undefined' ? 'undefined' : _typeof(getActivity)) === 'object' ? getActivity : { activity: getActivity };
      var all = yield Promise.all(Object.keys(functions).map(function () {
        var _ref3 = asyncToGenerator(function* (name) {
          var f = functions[name];
          var results = yield f(from, to, weekIndex);
          return {
            name: name,
            results: results
          };
        });

        return function (_x6) {
          return _ref3.apply(this, arguments);
        };
      }()));

      var activity = new Map();

      all.forEach(function (activityResults) {
        var name = activityResults.name;
        activityResults.results.forEach(function (instance) {
          if (activity.has(instance)) {
            activity.get(instance).push(name);
          } else {
            activity.set(instance, [name]);
          }
        });
      });
      return activity;
    });

    return function getActiveInstances(_x2, _x3, _x4, _x5) {
      return _ref2.apply(this, arguments);
    };
  }();

  var getActivityInRanges = function () {
    var _ref4 = asyncToGenerator(function* (getActivity, ranges) {
      var activityInRanges = [];
      for (var rangeIndex in ranges) {
        var range = ranges[rangeIndex];
        var activity = yield getActiveInstances(getActivity, range.from, range.to, rangeIndex);
        activityInRanges[rangeIndex] = activity;
      }
      return activityInRanges;
    });

    return function getActivityInRanges(_x7, _x8) {
      return _ref4.apply(this, arguments);
    };
  }();

  var getInstancesActiveInRange = function getInstancesActiveInRange(initialEventInRange, activity) {
    var activeInstances = new Map();
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = activity[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _ref5 = _step.value;

        var _ref6 = slicedToArray(_ref5, 2);

        var instanceId = _ref6[0];
        var instanceActivity = _ref6[1];

        if (initialEventInRange.has(instanceId)) {
          activeInstances.set(instanceId, instanceActivity);
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return activeInstances;
  };

  var buildRetentionMatrix = function buildRetentionMatrix(_ref7) {
    var dateRanges = _ref7.dateRanges,
        activityInRanges = _ref7.activityInRanges,
        groupedInitialEvents = _ref7.groupedInitialEvents;

    return dateRanges.map(function (range, rangeIndex) {
      var initialEventInRange = groupedInitialEvents[rangeIndex];

      var activity = Object.keys(activityInRanges).filter(function (index) {
        return index >= rangeIndex;
      }).map(function (index, i) {
        var activity = activityInRanges[index];
        var activeInstances = getInstancesActiveInRange(initialEventInRange, activity);
        var activeCount = activeInstances.size;
        var evalsCount = initialEventInRange.size;
        var percentage = Math.round(activeCount / evalsCount * 100);
        return {
          activeCount: activeCount,
          percentage: percentage,
          active: [].concat(toConsumableArray(activeInstances)).map(function (_ref8) {
            var _ref9 = slicedToArray(_ref8, 2),
                k = _ref9[0],
                v = _ref9[1];

            return { id: k, events: v };
          })
        };
      });

      return {
        range: range,
        activity: activity,
        cohort: [].concat(toConsumableArray(initialEventInRange.entries())).map(function (_ref10) {
          var _ref11 = slicedToArray(_ref10, 2),
              k = _ref11[0],
              v = _ref11[1];

          return { id: k, date: v };
        })
      };
    });
  };

  var buildMatrix = function () {
    var _ref13 = asyncToGenerator(function* (_ref12) {
      var _ref12$dateRanges = _ref12.dateRanges,
          dateRanges = _ref12$dateRanges === undefined ? generateRanges() : _ref12$dateRanges,
          getInitialEvents = _ref12.getInitialEvents,
          getActivity = _ref12.getActivity;

      var initialEvents = yield getInitialEvents();
      var groupedInitialEvents = groupInitialEventsByWeek(initialEvents, dateRanges);
      var activityInRanges = yield getActivityInRanges(getActivity, dateRanges);
      var matrix = buildRetentionMatrix({ dateRanges: dateRanges, groupedInitialEvents: groupedInitialEvents, activityInRanges: activityInRanges });
      return matrix;
    });

    return function buildMatrix(_x9) {
      return _ref13.apply(this, arguments);
    };
  }();

  var defaultPattern = ['#00bbde', '#fe6672', '#eeb058', '#8a8ad6', '#ff855c', '#00cfbb', '#5a9eed', '#73d483', '#c879bb', '#0099b6', '#d74d58', '#cb9141', '#6b6bb6', '#d86945', '#00aa99', '#4281c9', '#57b566', '#ac5c9e', '#27cceb', '#ff818b', '#f6bf71', '#9b9be1', '#ff9b79', '#26dfcd', '#73aff4', '#87e096', '#d88bcb'];

  var formatDateShort = function formatDateShort(date) {
    return date.toLocaleString('pl-PL', {
      timeZone: 'UTC',
      month: '2-digit',
      day: 'numeric'
    });
  };

  var formatDates = function formatDates(range) {
    return formatDateShort(new Date(range.from)) + ' - ' + formatDateShort(new Date(range.to));
  };

  var indicator = function indicator (i) {
    var cent = i % 100;
    if (cent >= 10 && cent <= 20) return 'th'
    var dec = i % 10;
    if (dec === 1) return 'st'
    if (dec === 2) return 'nd'
    if (dec === 3) return 'rd'
    return 'th'
  };

  function ordinal (i) {
    if (typeof i !== 'number') throw new TypeError('Expected Number, got ' + (typeof i) + ' ' + i)
    return i + indicator(i)
  }

  ordinal.indicator = indicator;
  var ordinal_1 = ordinal;

  /*! (c) Andrea Giammarchi (ISC) */var hyperHTML=function(e){var t=document.defaultView,r=/^area|base|br|col|embed|hr|img|input|keygen|link|menuitem|meta|param|source|track|wbr$/i,l="ownerSVGElement",c="http://www.w3.org/2000/svg",s="connected",f="dis"+s,d=/^style|textarea$/i,b="_hyper: "+(Math.random()*new Date|0)+";",h="\x3c!--"+b+"--\x3e",v=t.Event;try{new v("Event");}catch(e){v=function(e){var t=document.createEvent("Event");return t.initEvent(e,!1,!1),t};}var n,i=t.Map||function(){var n=[],r=[];return {get:function(e){return r[n.indexOf(e)]},set:function(e,t){r[n.push(e)-1]=t;}}},o=0,p=t.WeakMap||function(){var n=b+o++;return {get:function(e){return e[n]},set:function(e,t){Object.defineProperty(e,n,{configurable:!0,value:t});}}},a=t.WeakSet||function(){var t=new p;return {add:function(e){t.set(e,!0);},has:function(e){return !0===t.get(e)}}},m=Array.isArray||(n={}.toString,function(e){return "[object Array]"===n.call(e)}),g=b.trim||function(){return this.replace(/^\s+|\s+$/g,"")};function w(){return this}var u=function(e,t){var n="_"+e+"$";return {get:function(){return this[n]||y(this,n,t.call(this,e))},set:function(e){y(this,n,e);}}},y=function(e,t,n){return Object.defineProperty(e,t,{configurable:!0,value:"function"==typeof n?function(){return e._wire$=n.apply(this,arguments)}:n})[t]},N={},x={},E=[],C=x.hasOwnProperty,j=0,A={attributes:N,define:function(e,t){e.indexOf("-")<0?(e in x||(j=E.push(e)),x[e]=t):N[e]=t;},invoke:function(e,t){for(var n=0;n<j;n++){var r=E[n];if(C.call(e,r))return x[r](e[r],t)}}},k=function(e,t){return T(e).createElement(t)},T=function(e){return e.ownerDocument||e},O=function(e){return T(e).createDocumentFragment()},S=function(e,t){return T(e).createTextNode(t)},L=" \\f\\n\\r\\t",M="[^ "+L+"\\/>\"'=]+",$="[ "+L+"]+"+M,D="<([A-Za-z]+[A-Za-z0-9:_-]*)((?:",P="(?:=(?:'[^']*?'|\"[^\"]*?\"|<[^>]*?>|"+M+"))?)",B=new RegExp(D+$+P+"+)([ "+L+"]*/?>)","g"),R=new RegExp(D+$+P+"*)([ "+L+"]*/>)","g"),_=O(document),H="append"in _,z="content"in k(document,"template");_.appendChild(S(_,"g")),_.appendChild(S(_,""));var F=1===_.cloneNode(!0).childNodes.length,Z="importNode"in document,I=H?function(e,t){e.append.apply(e,t);}:function(e,t){for(var n=t.length,r=0;r<n;r++)e.appendChild(t[r]);},V=new RegExp("("+$+"=)(['\"]?)"+h+"\\2","gi"),W=function(e,t,n,r){return "<"+t+n.replace(V,q)+r},q=function(e,t,n){return t+(n||'"')+b+(n||'"')},G=function(e,t){return (l in e?ee:Y)(e,t.replace(B,W))},J=F?function(e){for(var t=e.cloneNode(),n=e.childNodes||[],r=n.length,i=0;i<r;i++)t.appendChild(J(n[i]));return t}:function(e){return e.cloneNode(!0)},K=Z?function(e,t){return e.importNode(t,!0)}:function(e,t){return J(t)},Q=[].slice,U=function(e){return X(e)},X=function(e){if(e.propertyIsEnumerable("raw")||/Firefox\/(\d+)/.test((t.navigator||{}).userAgent)&&parseFloat(RegExp.$1)<55){var n={};X=function(e){var t="^"+e.join("^");return n[t]||(n[t]=e)};}else X=function(e){return e};return X(e)},Y=z?function(e,t){var n=k(e,"template");return n.innerHTML=t,n.content}:function(e,t){var n=k(e,"template"),r=O(e);if(/^[^\S]*?<(col(?:group)?|t(?:head|body|foot|r|d|h))/i.test(t)){var i=RegExp.$1;n.innerHTML="<table>"+t+"</table>",I(r,Q.call(n.querySelectorAll(i)));}else n.innerHTML=t,I(r,Q.call(n.childNodes));return r},ee=z?function(e,t){var n=O(e),r=T(e).createElementNS(c,"svg");return r.innerHTML=t,I(n,Q.call(r.childNodes)),n}:function(e,t){var n=O(e),r=k(e,"div");return r.innerHTML='<svg xmlns="'+c+'">'+t+"</svg>",I(n,Q.call(r.firstChild.childNodes)),n};function te(e){this.childNodes=e,this.length=e.length,this.first=e[0],this.last=e[this.length-1];}te.prototype.insert=function(){var e=O(this.first);return I(e,this.childNodes),e},te.prototype.remove=function(){var e=this.first,t=this.last;if(2===this.length)t.parentNode.removeChild(t);else{var n=T(e).createRange();n.setStartBefore(this.childNodes[1]),n.setEndAfter(t),n.deleteContents();}return e};var ne=function(e,t,n){e.unshift(e.indexOf.call(t.childNodes,n));},re=function(e,t,n){return {type:e,name:n,node:t,path:function(e){var t=[],n=void 0;switch(e.nodeType){case 1:case 11:n=e;break;case 8:n=e.parentNode,ne(t,n,e);break;default:n=e.ownerElement;}for(e=n;n=n.parentNode;e=n)ne(t,n,e);return t}(t)}},ie=function(e,t){for(var n=t.length,r=0;r<n;r++)e=e.childNodes[t[r]];return e},oe=/acit|ex(?:s|g|n|p|$)|rph|ows|mnc|ntw|ine[ch]|zoo|^ord/i,ae=function(o,a){var u=void 0,l=void 0;return function(e){switch(typeof e){case"object":if(e){if("object"===u){if(!a&&l!==e)for(var t in l)t in e||(o[t]="");}else a?o.value="":o.cssText="";var n=a?{}:o;for(var r in e){var i=e[r];n[r]="number"!=typeof i||oe.test(r)?i:i+"px";}u="object",a?o.value=ce(l=n):l=e;break}default:l!=e&&(u="string",l=e,a?o.value=e||"":o.cssText=e||"");}}},ue=/([^A-Z])([A-Z]+)/g,le=function(e,t,n){return t+"-"+n.toLowerCase()},ce=function(e){var t=[];for(var n in e)t.push(n.replace(ue,le),":",e[n],";");return t.join("")},se=function(e,t){return e==t},fe=function(e){return e},de=function(e,t,n,r){if(null==r)t.removeChild(e(n,-1));else{var i=t.ownerDocument.createRange();i.setStartBefore(e(n,-1)),i.setEndAfter(e(r,-1)),i.deleteContents();}},he=function(e,t,n,r){r||(r={});for(var i=r.compare||se,o=r.node||fe,a=null==r.before?null:o(r.before,0),u=0,l=0,c=t.length-1,s=t[0],f=t[c],d=n.length-1,h=n[0],v=n[d];u<=c&&l<=d;)if(null==s)s=t[++u];else if(null==f)f=t[--c];else if(null==h)h=n[++l];else if(null==v)v=n[--d];else if(i(s,h))s=t[++u],h=n[++l];else if(i(f,v))f=t[--c],v=n[--d];else if(i(s,v))e.insertBefore(o(s,1),o(f,-0).nextSibling),s=t[++u],v=n[--d];else if(i(f,h))e.insertBefore(o(f,1),o(s,0)),f=t[--c],h=n[++l];else{var p=t.indexOf(h);if(p<0)e.insertBefore(o(h,1),o(s,0)),h=n[++l];else{for(var m=p,g=l;m<=c&&g<=d&&t[m]===n[g];)m++,g++;if(1<m-p)--p===u?e.removeChild(o(s,-1)):de(o,e,s,t[p]),l=g,s=t[u=m],h=n[g];else{var b=t[p];t[p]=null,e.insertBefore(o(b,1),o(s,0)),h=n[++l];}}}if(u<=c||l<=d)if(c<u){var w=n[d+1],y=null==w?a:o(w,0);if(l===d)e.insertBefore(o(n[l],1),y);else{for(var N=e.ownerDocument.createDocumentFragment();l<=d;)N.appendChild(o(n[l++],1));e.insertBefore(N,y);}}else null==t[u]&&u++,u===c?e.removeChild(o(t[u],-1)):de(o,e,t[u],t[c]);return n},ve=new a;function pe(){}pe.prototype=Object.create(null);var me=function(e){return {html:e}},ge=function e(t,n){return "ELEMENT_NODE"in t?t:t.constructor===te?1/n<0?n?t.remove():t.last:n?t.insert():t.first:e(t.render(),n)},be=function(e,t,n){for(var r=new pe,i=e.attributes,o=Q.call(i),a=[],u=o.length,l=0;l<u;l++){var c=o[l];if(c.value===b){var s=c.name;if(!(s in r)){var f=n.shift().replace(/^(?:|[\S\s]*?\s)(\S+?)=['"]?$/,"$1");r[s]=i[f]||i[f.toLowerCase()],t.push(re("attr",r[s],f));}a.push(c);}}for(var d=a.length,h=0;h<d;h++){var v=a[h];/^id$/i.test(v.name)?e.removeAttribute(v.name):e.removeAttributeNode(a[h]);}var p=e.nodeName;if(/^script$/i.test(p)){for(var m=document.createElement(p),g=0;g<i.length;g++)m.setAttributeNode(i[g].cloneNode(!0));m.textContent=e.textContent,e.parentNode.replaceChild(m,e);}},we=function(e,t){t(e.placeholder),"text"in e?Promise.resolve(e.text).then(String).then(t):"any"in e?Promise.resolve(e.any).then(t):"html"in e?Promise.resolve(e.html).then(me).then(t):Promise.resolve(A.invoke(e,t)).then(t);},ye=function(e){return null!=e&&"then"in e},Ne=function(r,i){var o={node:ge,before:r},a=!1,u=void 0;return function e(t){switch(typeof t){case"string":case"number":case"boolean":a?u!==t&&(u=t,i[0].textContent=t):(a=!0,u=t,i=he(r.parentNode,i,[S(r,t)],o));break;case"object":case"undefined":if(null==t){a=!1,i=he(r.parentNode,i,[],o);break}default:if(a=!1,m(u=t))if(0===t.length)i.length&&(i=he(r.parentNode,i,[],o));else switch(typeof t[0]){case"string":case"number":case"boolean":e({html:t});break;case"object":if(m(t[0])&&(t=t.concat.apply([],t)),ye(t[0])){Promise.all(t).then(e);break}default:i=he(r.parentNode,i,t,o);}else"ELEMENT_NODE"in(n=t)||n instanceof te||n instanceof w?i=he(r.parentNode,i,11===t.nodeType?Q.call(t.childNodes):[t],o):ye(t)?t.then(e):"placeholder"in t?we(t,e):"text"in t?e(String(t.text)):"any"in t?e(t.any):"html"in t?i=he(r.parentNode,i,Q.call(G(r,[].concat(t.html).join("")).childNodes),o):e("length"in t?Q.call(t):A.invoke(t,e));}var n;}},xe=function(t,n,e){var r=l in t,i=void 0;if("style"===n)return function(e,t,n){if(n){var r=t.cloneNode(!0);return r.value="",e.setAttributeNode(r),ae(r,n)}return ae(e.style,n)}(t,e,r);if(/^on/.test(n)){var o=n.slice(2);return o===s||o===f?(je&&(je=!1,function(){var i=function(e,t){for(var n=new v(t),r=e.length,i=0;i<r;i++){var o=e[i];1===o.nodeType&&a(o,n);}},a=function e(t,n){ve.has(t)&&t.dispatchEvent(n);for(var r=t.children||function(e){for(var t=[],n=e.childNodes,r=n.length,i=0;i<r;i++)1===n[i].nodeType&&t.push(n[i]);return t}(t),i=r.length,o=0;o<i;o++)e(r[o],n);};try{new MutationObserver(function(e){for(var t=e.length,n=0;n<t;n++){var r=e[n];i(r.removedNodes,f),i(r.addedNodes,s);}}).observe(document,{subtree:!0,childList:!0});}catch(e){document.addEventListener("DOMNodeRemoved",function(e){i([e.target],f);},!1),document.addEventListener("DOMNodeInserted",function(e){i([e.target],s);},!1);}}()),ve.add(t)):n.toLowerCase()in t&&(o=o.toLowerCase()),function(e){i!==e&&(i&&t.removeEventListener(o,i,!1),(i=e)&&t.addEventListener(o,e,!1));}}if("data"===n||!r&&n in t)return function(e){i!==e&&(i=e,t[n]!==e&&null==(t[n]=e)&&t.removeAttribute(n));};if(n in A.attributes)return function(e){i=A.attributes[n](t,e),t.setAttribute(n,null==i?"":i);};var a=!1,u=e.cloneNode(!0);return function(e){i!==e&&(i=e,u.value!==e&&(null==e?(a&&(a=!1,t.removeAttributeNode(u)),u.value=e):(u.value=e,a||(a=!0,t.setAttributeNode(u)))));}},Ee=function(n){var r=void 0;return function e(t){r!==t&&("object"==typeof(r=t)&&t?ye(t)?t.then(e):"placeholder"in t?we(t,e):e("text"in t?String(t.text):"any"in t?t.any:"html"in t?[].concat(t.html).join(""):"length"in t?Q.call(t).join(""):A.invoke(t,e)):n.textContent=null==t?"":t);}},Ce={create:function(e,t){for(var n=[],r=t.length,i=0;i<r;i++){var o=t[i],a=ie(e,o.path);switch(o.type){case"any":n.push(Ne(a,[]));break;case"attr":n.push(xe(a,o.name,o.node));break;case"text":n.push(Ee(a)),a.textContent="";}}return n},find:function e(t,n,r){for(var i=t.childNodes,o=i.length,a=0;a<o;a++){var u=i[a];switch(u.nodeType){case 1:be(u,n,r),e(u,n,r);break;case 8:u.textContent===b&&(r.shift(),n.push(d.test(t.nodeName)?re("text",t):re("any",u)));break;case 3:d.test(t.nodeName)&&g.call(u.textContent)===h&&(r.shift(),n.push(re("text",t)));}}}},je=!0;var Ae=new p,ke=function(){try{var e=new p,t=Object.freeze([]);if(e.set(t,!0),!e.get(t))throw t;return e}catch(t){return new i}}();function Te(e){var t=Ae.get(this);return t&&t.template===U(e)?Oe.apply(t.updates,arguments):function(e){e=U(e);var t=ke.get(e)||function(e){var t=[],n=e.join(h).replace(De,Pe),r=G(this,n);Ce.find(r,t,e.slice());var i={fragment:r,paths:t};return ke.set(e,i),i}.call(this,e),n=K(this.ownerDocument,t.fragment),r=Ce.create(n,t.paths);Ae.set(this,{template:e,updates:r}),Oe.apply(r,arguments),this.textContent="",this.appendChild(n);}.apply(this,arguments),this}function Oe(){for(var e=arguments.length,t=1;t<e;t++)this[t-1](arguments[t]);}var Se,Le,Me,$e,De=R,Pe=function(e,t,n){return r.test(t)?e:"<"+t+n+"></"+t+">"},Be=new p,Re=function(n){var r=void 0,i=void 0,o=void 0,a=void 0,u=void 0;return function(e){e=U(e);var t=a!==e;return t&&(a=e,o=O(document),i="svg"===n?document.createElementNS(c,"svg"):o,u=Te.bind(i)),u.apply(null,arguments),t&&("svg"===n&&I(o,Q.call(i.childNodes)),r=He(o)),r}},_e=function(e,t){var n=t.indexOf(":"),r=Be.get(e),i=t;return -1<n&&(i=t.slice(n+1),t=t.slice(0,n)||"html"),r||Be.set(e,r={}),r[i]||(r[i]=Re(t))},He=function(e){for(var t=e.childNodes,n=t.length,r=[],i=0;i<n;i++){var o=t[i];1!==o.nodeType&&0===g.call(o.textContent).length||r.push(o);}return 1===r.length?r[0]:new te(r)},ze=A.define;function Fe(e){return arguments.length<2?null==e?Re("html"):"string"==typeof e?Fe.wire(null,e):"raw"in e?Re("html")(e):"nodeType"in e?Fe.bind(e):_e(e,"html"):("raw"in e?Re("html"):Fe.wire).apply(null,arguments)}return Fe.Component=w,Fe.bind=function(e){return Te.bind(e)},Fe.define=ze,Fe.diff=he,(Fe.hyper=Fe).wire=function(e,t){return null==e?Re(t||"html"):_e(e,t||"html")},Se=Re,Le=new p,Me=Object.create,$e=function(e,t){var n={w:null,p:null};return t.set(e,n),n},Object.defineProperties(w,{for:{configurable:!0,value:function(e,t){return function(e,t,n,r){var i,o,a,u=t.get(e)||$e(e,t);switch(typeof r){case"object":case"function":var l=u.w||(u.w=new p);return l.get(r)||(i=l,o=r,a=new e(n),i.set(o,a),a);default:var c=u.p||(u.p=Me(null));return c[r]||(c[r]=new e(n))}}(this,Le.get(e)||(n=e,r=new i,Le.set(n,r),r),e,null==t?"default":t);var n,r;}}}),Object.defineProperties(w.prototype,{handleEvent:{value:function(e){var t=e.currentTarget;this["getAttribute"in t&&t.getAttribute("data-call")||"on"+e.type](e);}},html:u("html",Se),svg:u("svg",Se),state:u("state",function(){return this.defaultState}),defaultState:{get:function(){return {}}},dispatch:{value:function(e,t){var n=this._wire$;if(n){var r=new CustomEvent(e,{bubbles:!0,cancelable:!0,detail:t});return r.component=this,(n.dispatchEvent?n:n.childNodes[0]).dispatchEvent(r)}return !1}},setState:{value:function(e,t){var n=this.state,r="function"==typeof e?e.call(this,n):e;for(var i in r)n[i]=r[i];return !1!==t&&this.render(),this}}}),Fe}(window);

  var style = { "table": "retention-table", "row": "retention-row", "cell": "retention-cell", "header": "retention-header", "subtext": "retention-subtext" };

  var _templateObject = taggedTemplateLiteral(['<td class="', '" style="', '">', '</td>'], ['<td class="', '" style="', '">', '</td>']),
      _templateObject2 = taggedTemplateLiteral(['\n        <tr class="', '" style=', '>\n            <td>', '</td>\n            ', '\n            ', '\n        </tr>'], ['\n        <tr class="', '" style=', '>\n            <td>', '</td>\n            ', '\n            ', '\n        </tr>']),
      _templateObject3 = taggedTemplateLiteral(['', '<small class="', '">', '</small>'], ['', '<small class="', '">', '</small>']),
      _templateObject4 = taggedTemplateLiteral(['<th class="', '">', '</th>'], ['<th class="', '">', '</th>']),
      _templateObject5 = taggedTemplateLiteral(['\n        <table class="', '">\n            <thead>\n                <tr>\n                    <th class="', '">Cohort</th>\n                    <th class="', '">Size</th>\n                    ', '\n                </tr>\n            </thead>\n            ', '\n        </table>\n    '], ['\n        <table class="', '">\n            <thead>\n                <tr>\n                    <th class="', '">Cohort</th>\n                    <th class="', '">Size</th>\n                    ', '\n                </tr>\n            </thead>\n            ', '\n        </table>\n    ']);

  var renderCell = function renderCell(_ref, content) {
    var rangeIndex = _ref.rangeIndex,
        rangeCount = _ref.rangeCount;

    var bg = 'rgba(255,255,255,' + (rangeIndex + 1) / rangeCount * 0.3 + ')';
    return hyperHTML(_templateObject, style.cell, {
      backgroundColor: bg
    }, content);
  };

  var renderCohortRow = function renderCohortRow(_ref2) {
    var range = _ref2.range,
        rangeCount = _ref2.rangeCount,
        cohortIndex = _ref2.cohortIndex,
        cohort = _ref2.cohort,
        activity = _ref2.activity,
        colorPattern = _ref2.colorPattern;

    var evaluationsCount = cohort.length;

    return hyperHTML(_templateObject2, style.row, {
      backgroundColor: colorPattern[rangeCount - cohortIndex - 1]
    }, formatDates(range), renderCell({
      rangeCount: rangeCount,
      rangeIndex: 0
    }, evaluationsCount), activity.map(function (_ref3, i) {
      var activeCount = _ref3.activeCount,
          activeInstances = _ref3.activeInstances,
          percentage = _ref3.percentage;

      var percentageLabel = percentage ? percentage + '%' : '-';
      var content = hyperHTML(_templateObject3, activeCount, style.subtext, percentageLabel);
      return renderCell({
        rangeCount: rangeCount,
        rangeIndex: i + 1
      }, content);
    }));
  };

  var renderHeader = function renderHeader(content) {
    return hyperHTML(_templateObject4, style.header, content);
  };

  var renderTable = function renderTable(_ref4) {
    var container = _ref4.container,
        matrix = _ref4.matrix,
        _ref4$rangeSuffix = _ref4.rangeSuffix,
        rangeSuffix = _ref4$rangeSuffix === undefined ? 'week' : _ref4$rangeSuffix,
        _ref4$colorPattern = _ref4.colorPattern,
        colorPattern = _ref4$colorPattern === undefined ? defaultPattern : _ref4$colorPattern;

    var rangeCount = matrix.length;
    return container.appendChild(hyperHTML(_templateObject5, style.table, style.header, style.header, matrix.map(function (activity, index) {
      return renderHeader(ordinal_1(index + 1) + ' ' + rangeSuffix);
    }), matrix.map(function (cohort, cohortIndex) {
      return renderCohortRow({
        cohortIndex: cohortIndex,
        rangeCount: rangeCount,
        range: cohort.range,
        cohort: cohort.cohort,
        activity: cohort.activity,
        colorPattern: colorPattern
      });
    })));
  };

  var renderChart = function renderChart(_ref) {
    var container = _ref.container,
        matrix = _ref.matrix,
        _ref$rangeSuffix = _ref.rangeSuffix,
        rangeSuffix = _ref$rangeSuffix === undefined ? 'week' : _ref$rangeSuffix,
        _ref$colorPattern = _ref.colorPattern,
        colorPattern = _ref$colorPattern === undefined ? defaultPattern : _ref$colorPattern,
        _ref$options = _ref.options,
        options = _ref$options === undefined ? {} : _ref$options;

    var columns = [].concat(toConsumableArray(matrix)).reverse().map(function (cohort, index) {
      var label = formatDates(cohort.range);
      if (cohort.cohort.length === 0) {
        return [label];
      }
      var values = cohort.activity.map(function (_ref2) {
        var percentage = _ref2.percentage;
        return percentage;
      });
      return [label].concat(toConsumableArray(values));
    });

    return c3.generate(_extends({
      bindto: container,
      data: {
        columns: columns
      },
      axis: {
        x: {
          type: 'category',
          categories: matrix.map(function (range, i) {
            return ordinal_1(i + 1) + ' ' + rangeSuffix;
          })
        },
        y: {
          padding: {
            bottom: 0,
            top: 10
          },
          min: 0,
          max: 100,
          tick: {
            format: function format(x) {
              return x + ' %';
            }
          }
        }
      },
      legend: {
        show: false
      },
      color: {
        pattern: colorPattern
      }
    }, options));
  };

  exports.generateRanges = generateRanges;
  exports.buildMatrix = buildMatrix;
  exports.renderTable = renderTable;
  exports.renderChart = renderChart;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=retention.umd.js.map
